<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Your contact data in a QR Code</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-+0n0xVW2eSR5OomGNYDnhzAbDsOXxcvSN1TPprVMTNDbiYZCxYbOOl7+AMvyTG2x" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-gtEjrD/SeCtmISkJkNUaaKMoLD0//ElJ19smozuHV6z3Iehds+3Ulb9Bn9Plx0x4" crossorigin="anonymous"></script>
    <!--
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf/2.3.1/jspdf.es.min.js"></script>
    -->
    <script src="https://unpkg.com/@andreasremdt/simple-translator@latest/dist/umd/translator.min.js" defer></script>
    <!-- https://ekoopmans.github.io/html2pdf.js/ -->
    <script src="js/html2pdf.bundle.js"></script>
    <!-- https://github.com/jeromeetienne/jquery-qrcode -->
    <script src="js/qrcode.js"></script>
    <!--
    <link rel="stylesheet" href="style.css">
    <script src="script.js"></script>
    -->
    <style>
      .hidden {
        display: none;
      }
    </style>
  </head>
  <body>
    <div class="container">
      <main>
        <h1 id="heading"></h1>
        <div id="intro"></div>
        <form id="form">
          <div class="form-group">
          <label for="firstname" data-i18n="label.firstname">Firstname</label>
          <input type="input" class="form-control" id="firstname" required placeholder="Your firstname" data-i18n="placeholder.firstname" data-i18n-attr="placeholder">
          </div>
          <div class="form-group">
          <label for="lastname" data-i18n="label.lastname">Name</label>
          <input type="input" class="form-control" id="lastname" required placeholder="Your name" data-i18n="placeholder.lastname" data-i18n-attr="placeholder">
          </div>
          <div class="form-group">
          <label for="email" data-i18n="label.email">Email address</label>
          <input type="email" class="form-control" id="email" required placeholder="Your email" data-i18n="placeholder.email" data-i18n-attr="placeholder">
          <!--
          <small id="email" class="form-text text-muted">Wir brauchen die Emailadresse, um dir das Ticket zu schicken.</small>
          -->
          </div>
          <div class="form-group">
          <label for="phone" data-i18n="label.phone">Phone Number</label>
          <input type="tel" pattern="[0-9]{3} [0-9]{3} [0-9]{2} [0-9]{2}" class="form-control" id="phone" required placeholder="Your phone number" data-i18n="placeholder.phone" data-i18n-attr="placeholder">
          <!--
          <small id="emailHelp" class="form-text text-muted">Die Telefonnummer wird für das Contact Tracing gebraucht.</small>
          -->
          </div>
          <button type="button" id="generate" class="btn btn-primary" data-i18n="button.generate">Generate the QR Code</button>
          <!--
          <button type="button" id="fill" class="btn btn-primary">Fill</button>
          -->
        </form>
        <div id="output">
          <div id="output-intro"></div>
          <div id="data">
            <p><span id="data-firstname"></span> <span id="data-lastname"></span></p>
            <p>✉ <span id="data-email"></span></p>
            <p>✆ <span id="data-phone"></span></p>
          </div>
          <div id="qrcode"></div>
        </div>
        <div id="action">
          <p>Du kannst diese Seite ausdrucken oder als <button type="button" id="download" class="btn btn-primary">PDF Downloaden</button></p>
          <p><button type="button" id="new" class="btn btn-primary">Neues Ticket</button></p>
        </div>
      </main>
    </div>
      <script type="text/javascript">
      manifest = {};
      window.onload = () => {
          document.getElementById('intro').classList.remove('hidden');
          document.getElementById('form').classList.remove('hidden');
          document.getElementById('output').classList.add('hidden');
          document.getElementById('action').classList.add('hidden');

          translate();
          document.querySelectorAll('input[type=tel]').forEach(el => el.addEventListener("keydown", function(e) {
            // console.log('down key', e);
            let is_digit = k => !isNaN(parseInt(k));
            // don't mess with the key if a modifier is down (except shift only)
            if (e.ctrlKey || e.altKey || e.metaKey ||
                e.key === 'ArrowLeft' || e.key === 'ArrowRight' ||
                e.key === 'Home' || e.key === 'End') {
              return;
            }
            // accept digits and deletion
            if (!is_digit(e.key) && e.key !== 'Backspace' && e.key !== 'Delete') {
              e.preventDefault();
              return;
            }
            // For swiss numbers limit the length to ### ### ## ##
            if (e.target.value.charAt(0) !== '+' && e.target.value.length >= 13) {

              if (e.key !== 'Backspace' && e.key !== 'Delete') {
                e.preventDefault();
                return;
              }
            }
          }));
          document.querySelectorAll('input[type=tel]').forEach(el => el.addEventListener("keyup", function(e) {
            const n = e.target.value.length;
            const i = e.target.selectionStart;

            let is_digit = k => !isNaN(parseInt(k));
            if (e.target.value.charAt(0) === '+') {
              // +12 45 123 12 121231231312
              // TODO: not implemented yet
            } else {
              // 077 123 12 12
              if (i == n) {
                if (is_digit(e.key)) {
                  if (n == 3 || n == 7 || n == 10) {
                    this.value += ' ';
                  } else if (n == 4 || n == 8 || n == 11) {
                    this.value = this.value.slice(0, -1) + ' ' + e.key;
                  }
                } else if (e.key === 'Backspace') {
                  if (e.target.value.slice(-1) === ' ') {
                    e.target.value = e.target.value.slice(0, -1);
                  }
                }
              }
            }
          }));

          var url = new URL(window.location.href);
          var base_url = url.protocol+'//'+url.host + url.pathname;
          const m = url.searchParams.has('m') ? url.searchParams.get('m') : 'manifest';
          fetch(base_url+m+'.json')
            .then(response => response.json())
            .then(data => readManifest(data));
      };

      function readManifest(data) {
        // console.log(data);
        manifest = data;
        if ('title' in data) {
          document.getElementById('heading').innerHTML = data.title;
          document.title = data.title;
        }
        if ('html-intro' in data) {
          document.getElementById('intro').innerHTML = data['html-intro'];
        }
      }

      document.getElementById('generate').onclick = (e) => {
        for (const el of document.getElementById('form').querySelectorAll("[required]")) {
          if (!el.reportValidity()) {
            return;
          }
        }

        document.getElementById('intro').classList.add('hidden');
        document.getElementById('form').classList.add('hidden');
        document.getElementById('output').classList.remove('hidden');
        document.getElementById('action').classList.remove('hidden');

        console.log(manifest)
        if ('pdf-intro' in manifest) {

          document.getElementById('output-intro').innerHTML = manifest['pdf-intro'];
          console.log(manifest['pdf-intro']);
        }

        let firstname = document.getElementById('firstname').value;
        let lastname = document.getElementById('lastname').value;
        let email = document.getElementById('email').value;
        let phone = document.getElementById('phone').value;
        let qrcodeDiv = document.getElementById('qrcode');
        document.getElementById('data-firstname').textContent = firstname;
        document.getElementById('data-lastname').textContent = lastname;
        document.getElementById('data-email').textContent = email;
        document.getElementById('data-phone').textContent = phone;
        qrcodeDiv.innerHTML = '';
        new QRCode(qrcodeDiv, `${firstname}\t${lastname}\t${email}\t${phone}`);

      }

      document.getElementById('download').onclick = (e) => {
        let opt = {
            margin: 20,
            jsPDF:        { unit: 'mm', format: 'a4', orientation: 'portrait' },
            filename: 'schlofftheater.pdf',
        };
        html2pdf()
          .set(opt)
          .from(document.getElementById('output'))
          .save();
      };

      document.getElementById('new').onclick = (e) => {
        document.getElementById('form').classList.remove('hidden');
        document.getElementById('output').classList.add('hidden');
        document.getElementById('action').classList.add('hidden');
      };

      function translate () {
        var deCHTranslation = {
          label: {
            firstname: 'Vorname',
            lastname: 'Name',
            email: 'E-Mail-Adresse',
            phone: 'Telefonnummer',
          },
          button: {
            generate: 'QR-Code Generieren',
          },
          placeholder: {
            firstname: 'Vorname eingeben',
            lastname: 'Name eingeben',
            email: 'Email eingeben',
            phone: 'Telefonnummer eingeben',
          }
        };

        // Create a new instance of the translator
        // You can optionally pass options
        var translator = new Translator();

        // Add the language to the translator and translate the page
        translator.add('deCH', deCHTranslation).translatePageTo('deCH');
      }
      </script>
  </body>
</html>
